import java.util.Random;

public class TestTableaux {
    static void toutesLesMéthodes(int [] tab, int val) {
        System.out.println("Appel de toutes les méthodes sur le tableau fourni :");
        Tableaux.afficher(tab);
        System.out.println("Chaine : " + Tableaux.conversionChaine(tab));
        if (tab.length > 0) {
            System.out.println("Min : " + Tableaux.min(tab));
            System.out.println("Max : " + Tableaux.max(tab));
        }
        System.out.println("Indice min : " + Tableaux.indiceMin(tab));
        System.out.println("Indice max : " + Tableaux.indiceMax(tab));
        System.out.println("Indice de " + val + " : " + Tableaux.indiceDe(tab, val));
        int [] liste = Tableaux.listeIndicesMin(tab);
        if (liste != null) {
            System.out.print("Liste d'indices min : ");
            Tableaux.afficher(liste);
        }
        System.out.println("Est croissant : " + Tableaux.estCroissant(tab));
        System.out.println("Occurences max : " + Tableaux.occurrenceMax(tab));
        System.out.println("Palindrome : " + Tableaux.palindrome(tab));
        System.out.println("Retention d'eau : " + Tableaux.retentionEau(tab));
        System.out.println("Sous tableau de somme maximale : " + Tableaux.sousTableauDeSommeMax(tab));
        System.out.println("Sous séquence croissante de longueur maximale : " + Tableaux.sousSequenceCroissante(tab));
    }
    
    public static void main(String [] args) {
        int [] tabVide = {};
        int [] tabTrie = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
        int [] tabCroissantDecroissant = {1, 2, 3, 4, 5, 4, 3, 3, 2, 2, 1};
        int [] tabDecroissantCroissant = {6, 4, 2, 0, 1, 3, 5, 7};
        int [] tabExemple = { 1,4,2,3,2,5,3,4,2 };
        int [] tabDentsDeScie = { 1, 2, 4, 5, 3, 1, 2, 3, 4, 2, 3, 4, 5, 7, 3, 2, 1, 2, 3, 2, 2 };
        int [] tabPalindrome = { 1, 3, 3, 4, 5, 5, 4, 3, 3, 1 };
        int [] tabPalindrome2 = { 1, 3, 3, 4, 5, 4, 3, 3, 1 };
    
        toutesLesMéthodes(tabVide, 0);
        toutesLesMéthodes(tabTrie, 5);
        assert(Tableaux.indiceDe(tabTrie, 6) == 5);
        assert(Tableaux.estCroissant(tabTrie));
        toutesLesMéthodes(tabCroissantDecroissant, 5);
        assert(Tableaux.min(tabCroissantDecroissant) == 1);
        assert(Tableaux.indiceMin(tabCroissantDecroissant) == 0);
        int [] liste;
        liste = Tableaux.listeIndicesMin(tabCroissantDecroissant);
        assert((liste.length == 2) && (liste[0] == 0) && (liste[1] == tabCroissantDecroissant.length - 1));
        assert(Tableaux.occurrenceMax(tabCroissantDecroissant) == 2);
        assert(!Tableaux.estCroissant(tabCroissantDecroissant));
        assert(!Tableaux.palindrome(tabCroissantDecroissant));
        toutesLesMéthodes(tabDecroissantCroissant, 9);
        assert(Tableaux.indiceDe(tabDecroissantCroissant, 9) == -1);
        assert(Tableaux.max(tabDecroissantCroissant) == 7);
        assert(Tableaux.indiceMax(tabDecroissantCroissant) == tabDecroissantCroissant.length-1);
        assert(Tableaux.occurrenceMax(tabDecroissantCroissant) == 0);
        toutesLesMéthodes(tabExemple, 9);
        assert(Tableaux.retentionEau(tabExemple) == 6);
        toutesLesMéthodes(tabDentsDeScie, 7);
        assert(Tableaux.indiceDe(tabDentsDeScie, 4) == 2);
        assert(Tableaux.retentionEau(tabDentsDeScie) == 22);
        toutesLesMéthodes(tabPalindrome, 0);
        assert(Tableaux.palindrome(tabPalindrome));
        toutesLesMéthodes(tabPalindrome2, 3);
        assert(Tableaux.palindrome(tabPalindrome2));
        toutesLesMéthodes(ExempleTableau.tableauAleatoire(new Random(11), 10, -10, 10), 7);
    }
}
